;     386,  .
.386
;   - flat,    - stdcall
.model flat,stdcall
; Case-sensetive   
option casemap:none
; ,   -
include \masm32\include\windows.inc     ;  invoke...etc
include \masm32\include\kernel32.inc    ; DeviceIOControl, CreateFile... etc
includelib \masm32\lib\kernel32.lib     ;  
include \masm32\include\user32.inc      ; MessageBox
includelib \masm32\lib\user32.lib       ;  
;   ()
.data
;  ,   MessageBox 
MsgCaption  db "Iczelion's tutorial no.2",0
;    / VxD
AppName     db "DeviceIoControl",0
Success     db "The VxD is successfully loaded!",0
SerNumErr   db "Hard disk serial number not reading (IOS is busy ?) !",0
Failure     db "The VxD is not loaded!",0
Unload      db "The VxD is now unloaded!",0
;   VxD,   CreateFile-
VxDName     db "\\.\SER.VXD",0
; ,     VxD
InBuffer    dd offset SerNumber ;       
SerNumber   dw 256 dup(0) ;      VxD,    OK
;   ()
.data?
hVxD        dd ? ;      VxD
;   
.code
start:
;   VxD  CreateFile
;  VxD   "addr VxDName"
    invoke CreateFile,addr VxDName,0,0,0,0,FILE_FLAG_DELETE_ON_CLOSE,0
    .if eax!=INVALID_HANDLE_VALUE ; VxD   ?
        ;   VxD
        mov hVxD,eax
        ;    ,  VxD  
        invoke MessageBox,NULL,addr Success,addr AppName,MB_OK+MB_ICONINFORMATION
        invoke DeviceIoControl,hVxD,1,addr InBuffer,sizeof InBuffer,NULL,NULL,NULL,NULL
        ;   .  ,  eax = 0
        test eax,eax        
        jz @@ErrorReadSerial
        ;  .    
        call Print_SerialInfo
        jmp @@EndRead
@@ErrorReadSerial:        
        invoke MessageBox,NULL,addr SerNumErr,addr AppName,MB_OK+MB_ICONERROR
@@EndRead:        
        ;  VxD
        invoke CloseHandle,hVxD
        ;     VxD
        invoke MessageBox,NULL,addr Unload,addr AppName,MB_OK+MB_ICONINFORMATION
    .else
        invoke MessageBox,NULL,addr Failure,NULL,MB_OK+MB_ICONERROR
.endif
;  
invoke ExitProcess,NULL
; 
.data
SerialInfo  db "Serial Number of You Hard Drive: ???????????",0
.code
Print_SerialInfo proc
    ;        
    mov esi,offset SerNumber+20
    mov edi,offset SerialInfo+33
    mov ecx,15
    cld
    rep movsb
    invoke MessageBox,NULL,addr SerialInfo,addr MsgCaption,MB_OK
    ret
Print_SerialInfo endp
end start
