;     ( 256 ).
;   VxD    DeviceIOControl  
;    .      
; IOS- ,       
; .  VxD      win32  
; .  03F6h   .
; Coded by Chingachguk. 2002. 
; 
;     386
; "p"    ,
;        ;)
.386p
;     VxD
include vmm.inc 
include vwin32.inc
;     .
;  vmm.inc p p, p p   
; pp pp  .  p  
; DECLARE_VIRTUAL_DEVICE.    p: 
;
; Declare_Virtual_Device  Name, MajorVer, MinorVer, CtrlProc, DeviceID, \
; InitOrder, V86Proc, PMProc, RefData
;  -  VxD.   - 8 .    
;   p pp.     p  
; VxD . p   ,    DDB, 
; p '_DDB'   VxD. ,    
; 'FIRSTVXD'     pp, p 
; Declare_Virtual_Device   DDB  FIRSTVXD_DDB.
; ,     pp DDB  .DEF-. 
; MajorVerand, MinorVer -    p VxD. 
; CtrlProc -  p pp p  VxD. 
; p pp p (device control procedure) -  
; , p   p p . 
;     pp  pp .   
;   p Begin_Control_Dispatch,    
; p pp p,    p
;   VxDName_Control. Begin_Control_Dispatch p 
;'_Control',  , p  p (   p
;   VxD),       VxD  
; pp CtrlProc  p   '_Control'. 
; DeviceID - 16-   VxD. ID p 
;  ,   VxD  p   
; . 
;  VxD pp VxD p   p VxD.
;   p int20  device ID,  p
;   VxD,   p  . 
;  VxD     p p 
; p  p  p int 2Fh,  1607h. 
; - pp p p (TSR)  
; pp 2Fh,  1605h,  p  VxD. 
;  VxD     device ID,   
;    UNDEFINED_DEVICE_ID.   p  ID,
;   p   Microsoft'. 
; InitOrderInitialization - p p VxD.   VxD 
;   p p.
; Hpp: 
;
;           VMM_INIT_ORDER        EQU 000000000H
;           DEBUG_INIT_ORDER      EQU 000000000H
;           DEBUGCMD_INIT_ORDER   EQU 000000000H
;
;           PERF_INIT_ORDER       EQU 000900000H
;           APM_INIT_ORDER        EQU 001000000H
;   ,  VMM, DEBUG  DEBUGCMD -  p VxD, 
; p p,    PERF  APM. VxD   
;  p p.   VxD p p 
; p VxD  p ,    
;   ,   VxD, p p  p. 
;   VxD p p  ,  UNDEFINED_INIT_ORDER. 
; V86Proc  PMProc - VxD  pp API,   
; pp V86   p. V86Proc  PMProc  p 
;  API. ,  VxD     p 
; p ,     ,   
;  p .   VxD  p 
; p API  DOS-pp  pp  p. 
;    pp  API,   p  . 
; RefDataReference - ,  Input Output Supervisor 
; (IOS).  ,      
;   -    ppp pp, p  IOS.
DECLARE_VIRTUAL_DEVICE SER,1,0, SER_Control,\
     UNDEFINED_DEVICE_ID, UNDEFINED_INIT_ORDER 
;   Begin_Control_Dispatch. 
;  p     p p 
; pp p, p   p  
; p .    p   
;  pp,   pp   'FIRSTVXD'. p 
; p _Control  , p  .    
;   ,     pp CtrlPoc, p
; p Declare_virtual_device. pp  
;  "p"  (VxD_LOCKED_CODE_SEG). p 
; pp   .   ,  p 
;   p  VxD  ,
; p   p.     
; p Control_Dispatch. 
;
; Control_Dispatchmessage, function
; Hpp,   VxD p   Device_Init, 
; p pp p   : 
;
; Begin_Control_Dispatch FIRSTVXD
;   Control_Dispatch  Device_Init, OnDeviceInit
; End_Control_DispatchFIRSTVXD
; OnDeviceInit -   , p  p  
; Device_Init.       . 
;   VxD  p. 
;  p,  ,  VxD,  ,   DDB
;  p pp p.   DDB   
; p Declare_Virtual_Device  p pp p
;   p Begin_Control_Dispatch.
;   pp DDB,     p EXPORT  .DEF-. 
Begin_control_dispatch SER
	Control_Dispatch w32_DeviceIoControl, OnDeviceIoControl
End_control_dispatch SER
; End   . 
;    ,        :
;  ,    ,  
;   ..  ,     , 
;    . (    , 
;    exe-,  ?!)
; ,  , ,  (!).
;    VxD
VxD_PAGEABLE_DATA_SEG
;        -     
;        .
  Result dd ? ;   ,     0FFFFFFFFh (-1).
  Counter dw ? 
VxD_PAGEABLE_DATA_ENDS
;     .
VxD_PAGEABLE_CODE_SEG
BeginProc OnDeviceIoControl
;  ,  esi      - DIOCParams.
;       dd - ,    .
  assume esi:ptr DIOCParams
; VxD    ,     .
;   VxD        
.if [esi].dwIoControlCode==DIOC_Open ;   ?!
  xor  eax,eax ;  : eax=0.
;     .    -   .
;     -     ,   .
.elseif [esi].dwIoControlCode==1
  mov dword ptr Result,0FFFFFFFFh ;   
  pushad ;      ,   - pushad
  pushfd ;   . ,  .
;   ,  IOS    "Idle",
; ..      .     :
  mov ebx,0FFh 		;     "Idle"  IOS.
@@repeat_wait_IOS:
  int  20h 		; Call VxD
  dw   000Dh 		; Service Number: 0Dh "IOSIdleStatus
  dw   0010h 		; ID IOS: BlockDev/IOS (VxD ID 0010h)
  cli 			; Disable interrupts
  test eax,eax 		; Status (0-if idle, else nonzero)
  jz   @@begin_read 	;    
  sti			; , IOS 
  call Waiter		;  
  dec  ebx		;   - 1.
  jnz  @@repeat_wait_IOS ;   IOS
  jmp  @@not_reading	;   ;)
@@begin_read:		;    
  mov  word ptr Counter,0
@@TryAgain:
  mov  dx,03F6h
  mov  al,0Ah
  out  dx,al		; outportb(0x3F6,0x0A)
  call Waiter
@@Wait1: 
  mov  dx,01F7h
  in   al,dx
  call TimeOut
  test al,80h     	; while(inportb(0x1F7)&0x80);
  jnz  @@Wait1
  call Waiter
  mov  dx,01F6h
  mov  al,0A0h
  out  dx,al 		; outportb(0x1F6,0xA0+(drive<<4));
  call Waiter
@@Wait2: 
  mov  dx,01F7h
  in   al,dx
  call TimeOut 
  test al,40h   	; while(!(inportb(0x1F7)&0x40));
  jz   @@Wait2
  call Waiter
  mov  dx,01F7h
  mov  al,0ECh
  out  dx,al      	; outportb(0x1F7,0xEC);
  call Waiter
@@Wait3: 
  mov  dx,01F7h
  in   al,dx
  call TimeOut
  test al,08h     	; while(!(inportb(0x1F7)&0x08));
  jz   @@Wait3
  call Waiter
; for(i=0; i<256; i++) infoArray[i] = swap(inportw(0x1F0))
;      InBuffer   ebx
  mov  ebx,[esi].lpvInBuffer 
  mov  edi,[ebx] ;   ,    win32-
  mov  ecx,256
@@FillBuf:
  call Waiter
  mov  dx,01F0h
  in   ax,dx
  xchg al,ah
  mov  word ptr [edi],ax 
  inc  edi
  inc  edi
  loop @@FillBuf
  mov  dx,01F7h
  in   al,dx
  call TimeOut
  test al,80h     ; if(inportb(0x1F7)&0x80) continue;
  jz   @@ReadOK
  jmp  @@TryAgain
@@ReadOK:
  call Refresh_PORT03F6h
  mov  dword ptr Result,0h ;    -   .
@@not_reading:
  popfd ;     .. -  ?!
  popad
  mov  eax,dword ptr Result ;   eax  
.endif
  ret
EndProc OnDeviceIoControl
;   .   ,    ...;)
Waiter proc
  push ecx	
  mov  ecx,0FFh
@@Wait: 
  loop @@Wait
  pop  ecx
  ret
Waiter endp
TimeOut proc
  inc  word ptr Counter
  jnz  @@TimeDone
  pop  eax
  call Refresh_PORT03F6h
  jmp  @@not_reading
@@TimeDone:
  retn
TimeOut endp
;Bitfields for fixed disk controller data register(03F6h):
;Bit(s)	Description	(Table P197)
; 7-4	reserved
; 3	=0  reduce write current
;	=1  head select 3 enable
; 2	disk reset enable
; 1	disk initialization disable
; 0	reserved
; 0Ah = 10 = 8+2 = 1010 -  out /  in al,03F6h -> 50h=   = 0
Refresh_PORT03F6h proc
  mov  dx,03F6h
  in   al,dx
  and  al,11110001b
  out  dx,al
  ret
Refresh_PORT03F6h endp
VxD_PAGEABLE_CODE_ENDS
end